% l1dantzig_update.m
% LASSO and Dantzig Selector update homotopy.

clear

% signal length
N = 64;
% number of spikes to put down
T = 15;
% number of observations to make
K = 50;

% random +/- 1 signal
x = zeros(N,1);
q = randperm(N);
x(q(1:T)) = randn(T,1);%sign(randn(T,1)).*randint(T,1,256);

% measurement matrix
disp('Creating measurment matrix...');
G = randn(K,N);
% G = orth(G')';
n_m = 10;
A = G(1:end-n_m,:);
b = G(end-(n_m-1):end,:);

disp('Done.');

% observations
y = A*x;
% initial guess = min energy
x0 = A'*inv(A*A')*y;
tau = 1e-2;


% large scale
AtA = A'*A;
% [xp, lame, gamma_x, gamma_lambda] = PD_pursuit_function(A, AtA, y, tau, 4*N); %DS
[xp, gamma_x, xp_iter] = Lasso_homotopy_function_iter(A, AtA, y, tau,4*N); %Lasso

Ag = [A zeros(K-n_m,N); eye(N) -eye(N)];
yg = [y;zeros(N,1)];
[xg, gamma_xg, xg_iter] = Lasso_homotopy_function_iter(Ag, [], yg , tau,4*N); %Lasso

figure(1); clf;  hold on
figure(2); clf; plot(A'*(A*xp-y)); hold on

wt_count = 1000;
table_wt = zeros(wt_count,3);
wt_s= 0;%0.009203165152907
wt_e= 1;%0.00920316515301
wt_iter = linspace(wt_s,wt_e,wt_count);

beta = 0;
e0 = 0;
gamma_xh = gamma_x;
xp2 = xp;
epsilon = 0;
gamma_x_old = gamma_x;
gamma_x2_old = gamma_x;
xp_old = xp;
delx_old = xp;
delx_mat = [];
marker = ['b';'r';'k';'g';'m'];
m_ind = 1;
in_iter = 0;
wt_old = 0;
for kk = 1:wt_count
    % wt = epsilon;
    wt = wt_iter(kk)

    w = b*x;
    y2 = [y; sqrt(wt)*w];
    G = [A; sqrt(wt)*b];
    GtG = G'*G;
    xp2_old = xp2;

    [xp2, gamma_x2, xp2_iter] = Lasso_homotopy_function_iter(G, GtG, y2, tau,4*N); %Lasso
    %[xp2, lamf, gamma_x2, gamma_lambda2] = PD_pursuit_function(G, GtG, y2, tau, 4*N); %DS

    wt
    in_iter = in_iter+1;
    gx2_old = (gamma_x2_old);
    if in_iter>1 & isempty(setxor(gamma_x2,gamma_x_old))
        delx = (xp2-xp_old)/norm(xp2-xp_old);
        iU = inv(A(:,gx2_old)'*A(:,gx2_old)+wt_old*b(:,gx2_old)'*b(:,gx2_old));
        delx_h = -iU*b(:,gx2_old)'*inv(eye(n_m)+(wt-wt_old)*b(:,gx2_old)*iU*b(:,gx2_old)')*(b*xp_old-w);
        delx_h = inv(A(:,gx2_old)'*A(:,gx2_old)+wt*b(:,gx2_old)'*b(:,gx2_old))*(b(:,gx2_old)'*(b*xp_old-w));
        delx_h = delx_h./norm(delx_h);
        figure(100); plot(delx_h./delx(gx2_old)); hold on
        if in_iter>2
            delx_mat(:,in_iter-2) = delx(gx2_old);
        end
        figure(3); plot(delx(gx2_old)./delx_old(gx2_old)); 
        if in_iter == 2
            delx_old = delx;
            figure(3); clf; hold on
            figure(100); clf; hold on
            
        end
    end
    wt_old = wt;
    gamma_x2_old = gamma_x2;
    if ~isempty(setxor(gamma_x2,gamma_x_old))
        [setxor(gamma_x2,gamma_x_old); length(gamma_x2) > length(gamma_x_old)]
        gamma_x_old = gamma_x2;
        del_x_old = xp2-xp_old;
        m_ind = mod(m_ind+1,5)+1;
        xp_old = xp2;
        delx_mat = [];
        in_iter = 0;
    end
         
    figure(1); plot(xp2-xp_old,marker(m_ind)); hold on;
    figure(2); plot(G'*(G*xp2-y2),[marker(m_ind),'.']); hold on;
end

figure(2); plot(G'*(G*xp2-y2),'k'); shg