function [alpha, beta, type, d] = fast_givens(x,d)
% Golub pg 221

if x(2)
    alpha = -x(1)/x(2); beta = -alpha*d(2)/d(1); gamma = -alpha*beta;
    if gamma <= 1
        type = 1; 
        tau = d(1); d(1) = (1+gamma)*d(2); d(2) = (1+gamma)*tau;
    else
        type = 2;
        alpha = 1/alpha; beta = 1/beta; gamma = 1/gamma;
        d(1) = (1+gamma)*d(1); d(2) = (1+gamma)*d(2);
    end
else
    type = 2;
    alpha = 0; beta = 0;
end