function [Q A] = qr_givens(A)
% Golub pg 229

[m n] = size(A);

% d = ones(m,1);
% for j = 1:n
%     for i=m:-1:j+1
%         [alpha, beta, type, d(i-1:i)] = fast_givens(A(i-1:i,j),d(i-1:i));
%         if type == 1
%             A(i-1:i,j:n) = [beta 1; 1 alpha]'*A(i-1:i,j:n);
%         else
%             A(i-1:i,j:n) = [1 alpha; beta 1]'*A(i-1:i,j:n);
%         end
%     end
% end

Q = eye(m);
for j = 1:n
    for i=m:-1:j+1
        [c, s] = givens(A(j,j), A(i,j));
        A([j i],j:n) = [c s; -s c]'*A([j i],j:n);   
        Q([j i],:) = [c s; -s c]'*Q([j i],:);
    end
end
Q = Q';

% Update qr with MGS (appending column at the end)
% Downdate qr using Givens rotations as specified in Golub pg. 607

