clear 
close all


J = 5;
N = 256;
band = J-1; % J+1th band is lowest freq. 
% (use J for lowest because we are taking transform in two stages)
% J - scaling function
% < J - wavelet function

[Faf, Fsf] = FSfarras;
[af, sf] = dualfilt1; % with FSfarras and dualfilt phi_h + j phi_g is negative freq.
[Faf, Fsf, af, sf] = BiOrthDualFilt_final; % with this one psi_h + j psi_g is negative freq.

h_g = 1;
x=zeros(1,N);                  % create generic signal whose values are all 0
w1 = dwt(x,1,Faf{h_g});                % analysis filter banks (1 stages)
w2 = dwt(w1{2},J-1,af{h_g});
w2{band}(N/2^J/2)=1;                      % setting one of the wavelet coefficients to be 1
y1 = idwt(w2,J-1,sf{h_g});               % synthesis filter banks (3 stages)
y2 = w1; 
y2{2} = y1;
yh = idwt(y2,1,Fsf{h_g});

h_g = 2;
x=zeros(1,N);                  % create generic signal whose values are all 0
w1 = dwt(x,1,Faf{h_g});                % analysis filter banks (1 stages)
w2 = dwt(w1{2},J-1,af{h_g});
w2{band}(N/2^J/2)=1;                      % setting one of the wavelet coefficients to be 1
y1 = idwt(w2,J-1,sf{h_g});               % synthesis filter banks (3 stages)
y2 = w1; 
y2{2} = y1;
yg = idwt(y2,1,Fsf{h_g});

figure(1);
plot([yh(:) yg(:)]);            % Plot the wave
title('Magnitude of 1-D complex wavelet transform') 
xlabel('t');                    
ylabel('\psi(t)');
figure(2)
plot(abs(fft(yh+1i*yg)));            % Plot the wave
title('DFT of 1-D complex wavelet transform') 
xlabel('t');                    
ylabel('F(\psi(t))');







